version 10.0

* syntax is var1 wgt1 var2 wgt2 zmax #test-points

* syntax is "fgt var wgt z alpha"

program define fgtdom
  local var      `1'
  local wgt      `2'
  local z      = `3'
  local alpha  = `4'

  local s    = `alpha' + 1
  local afac = round(exp(lnfactorial(`alpha')),1)
   tempvar N ind gap ngap
    quietly egen     `N'    = sum(`wgt')
    quietly gen      `gap'  = `z' - `var'
    quietly gen      `ind'  = `gap' >= 0
    quietly gen      `ngap' = `gap' / `z'
     quietly replace `gap'  = (`gap'^`alpha')  * `ind'
     quietly replace `ngap' = (`ngap'^`alpha') * `ind'
  summarize  `gap' [aw=`wgt'], meanonly
  local dhat  = r(mean) / `afac'
  summarize `ngap' [aw=`wgt'], meanonly
  local phat  = r(mean)
     quietly replace `gap'  = `gap' ^ 2
  summarize `gap' [aw=`wgt'], meanonly
  local vdhat= (1/`N')*((r(mean)/(`afac'^2)) - (`dhat'^2))

  global P`alpha' = `phat'
  global D`s'     = `dhat'
  global VD`s'    = `vdhat'

  display "P"`alpha' "  = " `phat'
  display "D"`s'     "  = " `dhat'
  display "VD"`s'    " = "  `vdhat'

end


program define dom   
  local x1     `1'
  local wgt1   `2'
  local x2     `3'
  local wgt2   `4'
  local zmax = `5'
  local num  = `6'

 summarize `x1', meanonly
 local min1   = r(min)
 summarize `x2', meanonly
 local min2   = r(min)
 local min    = max(`min1',`min2')
 local inter  = (`zmax'-`min')/(`num'-1)
 local min    = `min' + 3*`inter'
 local inter  = (`zmax'-`min')/(`num'-1)
 local done   = 0
 local s      = 1
 tempvar ind


display " "
display "Minimum test point is " `min'
display " "
display "Maximum test point is " `zmax'
display " "

 if `zmax' <= `min' {
        local done = 1
        display " "
        display in red "Error: " in yellow "Max test point is not larger than min test point!"
        display " "
              }


 
 while `done' == 0 {
        display " "
        display "Order " `s'
        display "Z          D1        D2        t-statistic"
        local alpha = `s' - 1
        local  i    = 2
        local  z    = `min'
        quietly gen `ind' = .
        while `z'  <= `zmax' +0.000001 {
              quietly fgtdom `x1' `wgt1' `z' `alpha'
              local  D1 =  ${D`s'}
              local VD1 =  ${VD`s'}
              quietly fgtdom `x2' `wgt2' `z' `alpha'
              local  D2 =  ${D`s'}
              local VD2 =  ${VD`s'}
              local   t = (`D2'-`D1')/sqrt(`VD1'+`VD2')
              display %5.4f `z' "    " %5.4f `D1' "    " %5.4f `D2'  "    " %4.2f `t'
              local ind0 = 1.5
              if `t' >=  1.96 { 
			        local ind0 = 1 
			      }
              if `t' <= -1.96 {
			        local ind0 = 2 
			      }
              quietly replace `ind' = `ind0' if _n==`i'
              local z = `z' + `inter'
              local i = `i' + 1
              }
        summarize `ind', meanonly
         if r(mean) == 1 { 
		               local done = 1 
                               global Dorder = -`s'
                               display ""
                               display "Dominance achieved at order " `s'
                               local s = 1
			   }
         if r(mean) == 2 { 
		               local done = 1 
                               global Dorder = `s'
                               display ""
                               display "Dominance achieved at order " `s'
                               local s = 1
			   }
         if `s' >= 3        { 
		               local done = 1 
                               global Dorder = 0
                               display ""
                               display "Dominance not achieved up to order 3"
			   }
        drop `ind'
        local s = `s' + 1
        }


end
